/*
    Flexisip, a flexible SIP proxy server with media capabilities.
    Copyright (C) 2010-2021  Belledonne Communications SARL, All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "client.hh"

using namespace std;
namespace flexisip {
namespace pushnotification {

void Client::incrSentCounter() {
	if (mService) {
		if (auto counter = mService->getSentCounter()) {
			counter->incr();
		}
	}
}

void Client::incrFailedCounter() {
	if (mService) {
		if (auto counter = mService->getFailedCounter()) {
			counter->incr();
		}
	}
}

} // namespace pushnotification
} // namespace flexisip
